program HHCoaut;

{konverze Heijdenovy databaze v pgn - odstraneni prusvihu se jmeny spoluautoru}

{$APPTYPE CONSOLE}

uses
  SysUtils;

(*Problem - ve formatu CBH jde hledat jen prvni autor,
  protoze druhy je v krestnim jmenu.
  V pgn to vypada takto
  [White "Vlasak, E"]
         "Vlasak, E HlinkaM HusakK"

  a ja potrebuju
         "Vlasak_Hlinka_Husak, EMK

 *)

var Zpracovanych :longint;

    InPGN,OutPGN: TextFile;
    JmenoVstupu, JmenoVystupu: string;
    {to je pro jmena PGN souboru}
    PGNLine:string; {hlavni pracovni retez}

    HHPlneJmeno, NoveJmeno, Slovo, NovePrijmeni, NoveKresni: string;



procedure Konec(s:string);
 begin writeln(s);
       halt;
 end;




{------------------------cteni parametru a inicializace---------------}

procedure CtiParams;

  begin
   writeln('HHCoaut (C) Emil Vlasak 2002');
   writeln('Conversion of HvdH coauthor names');
   writeln;
   if ParamCount=0 then
     begin
       writeln('using: HHCoaut <input PGN name>');
       writeln('       output is new.pgn');
       halt;
     end;

   JmenoVstupu:=ParamStr(1);
   JmenoVystupu:=ExtractFileDir(JmenoVstupu)+'new.pgn';

  end;

 {--------------------prace s PGN--------------------}

 procedure OtevriDatabaze;
   begin
   {$I-}
    assign(InPGN,JmenoVstupu);
    if IOResult<>0 then Konec('Input PGN database not found');
    reset(InPGN);
    if IOResult<>0 then Konec('Input PGN database not found');

    assign(OutPGN,JmenoVystupu);
    rewrite(OutPGN);
    if IOResult<>0 then Konec('Cannot create new.pgn.');

    (*assign(Unknown,'unknown.txt');
    rewrite(Unknown);
    if IOResult<>0 then Konec('Cannot create unknown.txt.');*)

   {$I+}
   end;

 procedure ZavriDatabaze;
   begin
    close(InPGN);
    close(OutPGN);
    {close(Unknown);}
   end;

 {----------------jmena ----------------------------------------}

 procedure VyloupniJmeno;
  {v PGNLine je radka [White "neco"] a ja chci to neco do globalni promenne HHPlneJmeno}
  {navic upravit PGNLine aby koncil pred prvni uvozovkou}
  var pomb:byte;

  begin
   pomb:=pos('"',PGNLine);
   HHPlneJmeno:=copy(PGNLine,pomb+1,length(PGNLine)-pomb-2);
    {dost odflakle, orezu tim posledni uvozovku a zavorku}
   PGNLine:=copy(PGNLine,1, pomb-1);
    {bez uvozovky}
  end;


  function DejSlovo:Boolean;
    {do promenne Slovo da dalsi slovo z HHPlneJmeno, ktery pak o nej osekne}
    var pomb:byte;
    begin
      DejSlovo:=false;
      Trim(HHPlneJmeno);
      pomb:=pos(' ',HHPlneJmeno);
      if pomb=0 then begin
                       if HHPlneJmeno='' then exit;{neni dalsi slovo}
                       Slovo:=HHPlneJmeno;
                       HHPlneJmeno:='';
                       DejSlovo:=true;
                       exit;
                 end;
      Slovo:=copy(HHPlneJmeno,1,pomb-1);
      HHPlneJmeno:=copy(HHPlneJmeno, pomb+1, length(HHPlneJmeno)-pomb);
      DejSlovo:=true;
    end; {DejSlovo}

 function HledejZlom:byte;
   {hleda zlom ve slove typu VlasakE, zlom ukayuje na E}
   var pomz:byte;
       pomc:char;

   begin
     pomz:=length(Slovo); {nejcasteji je zlom poslednim pismenem}
     repeat
       pomc:=Slovo[pomz-1];
       if (pomc in ['A'..'Z']) then dec(pomz) else break;
     until false;
    HledejZlom:=pomz;
   end;

 procedure UpravaSpoluAutoru;
    {HHPlneJmeno je vstup, NoveKresni a NovePrijmeni vystup}
    var pomb, zlom:byte;

    begin
     {doplneno 10/2002}
     NoveKresni:='';
     NovePrijmeni:='';

     if DejSlovo then
        begin {prvni slovo s s carkou na konci}
         pomb:=length(Slovo);
         if Slovo[pomb]=',' then delete(Slovo,pomb,1); {nechci carku}
         NovePrijmeni:=Slovo;
        end;

     if DejSlovo then
        begin {druhe slovo je zkratka}
          NoveKresni:=Slovo;
        end;


     while DejSlovo do {cyklus pro dalsi slova}
      begin
       pomb:=length(Slovo);
       zlom:=HledejZlom; {KuznecovAP ukazuje na A}
       NovePrijmeni:=NovePrijmeni+'_'+ copy(Slovo,1,zlom-1);
       NoveKresni:=NoveKresni+'_'+ copy(Slovo, zlom, pomb-zlom+1);
      end;

    end;

 procedure ZkomponujJmeno;
   begin

    {doplneno 10/2002}
    NoveJmeno:=NovePrijmeni;
    if NoveKresni<>'' then NoveJmeno:=NoveJmeno+', '+NoveKresni;

   end;

 procedure VratNoveJmeno;
  {doplnit do PGNLine konvertovany retez NovyZdroj}
  begin
   PGNLine:=PGNLine+'"'+NoveJmeno+'"]';

  end;


 procedure ZpracujPGNLine;

  begin
   if pos('[White ',PGNLine)<>1 then exit; {neni to konvertovana radka}
   inc(Zpracovanych); if (Zpracovanych mod 1000)=0 then writeln(Zpracovanych);
   VyloupniJmeno; {do HHPlneJmeno}
   UpravaSpoluautoru;
   ZkomponujJmeno;
   VratNoveJmeno;
  end;
{----------------main -----------------------}


begin

  Zpracovanych:=0;
  CtiParams;
{$I-}
  OtevriDatabaze;

  {------- hlavni cykl prevodu----------------}
   while not eof(InPGN) do
     begin
      readln(InPGN, PGNLine);
      if IOResult<>0 then Konec('Cannot read input database');
      ZpracujPGNLine;
      writeln(OutPGN,PGNLine);
      if IOResult<>0 then Konec('Cannot write to output database');
     end;
  ZavriDatabaze;
{$I+}

  writeln('Database converted ',Zpracovanych, ' studies.');
  

end.
