program HHKonv;

{konverze pgn zdroju z Heijdenova formatu do normalniho}

{$APPTYPE CONSOLE}

uses
  SysUtils;

(*Popis HH formatu:
 [volitelne vyznamenani] [kod turnaje] [volitelne#cislo nebo -cislo] [opakovane {pole}|@cislo]

 vyznamenani [volitelne cislo nebo cislo/cislo].[p|c|hm]
 kod turnaje -  vetsinou [pismeno][pismeno][cislo][cislo]
 {pole} obsahuje
  v verze, c corekce, m modifikace, s jine reseni ney autorske
  pl plagiat, tw twin dvojnik, te teoreticka koncovka, ea analyza koncovky,
  tt tematicky turnaj
 tecka muze byt i v cisle studie

 Ucelem je
 1. prevest kod turnaje do nazvu turnaje, prevod je v souboru
    hh2000.txt, kde je zleva kod turnaje a zbytek radku nazev turnaje
    v te verzi je 1711 radku
 2. preskupit tak, abz nayev turnaje bzl pravni, pak vyznamenani a
    specialni pole
 *)

var Nenalezenych, Zpracovanych, Dlouhych: longint;

    InPGN,OutPGN, Unknown: TextFile;
    JmenoVstupu, JmenoVystupu: string;
    {to je pro jmena PGN souboru}
    PGNLine:string; {hlavni pracovni retez}



procedure Konec(s:string);
 begin writeln(s);
       halt;
 end;

{------------- nacteni prevodni tabulky -----------------------}

var KodTur: array [1..4000] of string[4];
    NazTur: array [1..4000] of string[150];
    DelkaTabulky:integer;

procedure NactiPrevodTurnaje;
{nacte soubor hhkonv.txt}
{$I-}
var kontab:TextFile;
    i,pozice:integer;
    works, radek:string;

  begin
    assign(kontab,'hhkonv.txt');
    reset(kontab);
    if IOResult<>0 then Konec('Error reading hhkonc.txt. Does it exist?');
    i:=1;
    while not eof(kontab) do
          begin readln(kontab,works);
                if (pos('/*',works)<>0) then continue; {radka s poznamkou}
                
                pozice:=pos(' ',works);
                if (pozice=0) or (pozice>5)
                           then
                            begin
                             Str(i,radek);
                             Konec('Bad file hhkonv.txt, line: '+radek);
                            end;
                KodTur[i]:=Trim(copy(works,1,pozice-1));
                NazTur[i]:=Trim(copy(works, pozice+1, length(works)-pozice));
                inc(i);
           end;
    dec(i);
    if IOResult<>0 then Konec('Error reading conversion file');
    Str(i,radek);
    writeln('The conversion file hhkonv.txt read, '+radek+' lines.');
    DelkaTabulky:=i;
    close(kontab);
{$I+}
  end;

{----------procedury pro konverzi zdroje ---------------------}

var HHZdroj, HHVyzn, HHTurn, HHNrSt, HHSpec, Slovo, Turnaj, NovyZdroj: string;
    {pro nasledujici procedury upravy turnaju}

procedure AnalyzujHHZdroj;

  function DejSlovo:Boolean;
    {do promenne Slovo da dalsi slovo z HHZdroj, kterz pak o nej osekne}
    var pomb:byte;
    begin
      DejSlovo:=false;
      Trim(HHZdroj);
      pomb:=pos(' ',HHZdroj);
      if pomb=0 then begin
                       if HHZdroj='' then exit;{neni dalsi slovo}
                       Slovo:=HHZdroj;
                       HHZdroj:='';
                       DejSlovo:=true;
                       exit;
                 end;
      Slovo:=copy(HHZdroj,1,pomb-1);
      HHZdroj:=copy(HHZdroj, pomb+1, length(HHZdroj)-pomb);
      DejSlovo:=true;
    end; {DejSlovo}

 var ptecka,pslozzav,pzavinac,phash,pminus :byte;

 begin {Analyzuj HHZdroj}
   HHVyzn:='';
   HHTurn:='';
   HHNrSt:='';
   HHSpec:='';

   while DejSlovo
    do
     begin
      Slovo:=Trim(Slovo);
      ptecka:= pos('.c',Slovo)+pos('.p',Slovo)+pos('.hm',Slovo);
      pslozzav:= pos('{',Slovo);
      pzavinac:= pos('@',Slovo);
      phash:= pos('#',Slovo);
      pminus:= pos('-',Slovo);

      if ptecka+pslozzav+pzavinac+phash+pminus=0 then
          begin HHTurn:=Slovo; continue; end;

      if (pslozzav+pzavinac)<>0 then
          begin  if HHSpec='' then HHSpec:=Slovo
                              else HHSpec:=HHSpec+' '+Slovo;
                 continue;
          end;

      if (phash+pminus)<>0 then
          begin {separace}
            HHTurn:=copy(Slovo,1,phash+pminus-1);
            HHNrSt:=copy(Slovo,phash+pminus,length(Slovo)-phash-pminus+1);
          end;

      if ptecka<>0 then
          begin HHVyzn:=Slovo; continue; end;

     end;
 end;

 procedure NajdiTurnaj;
  var i:integer;


    begin
     Turnaj:='';
     for i:=1 to DelkaTabulky do
      begin
       if HHTurn=KodTur[i] then begin Turnaj:=NazTur[i]; break; end;
      end;
     if Turnaj='' then
         begin  Turnaj:=HHTurn; {aspon tam necham kod turnaje}
                inc (Nenalezenych);
                writeln (Unknown, 'unknown: '+HHTurn);
         end;
    end;

 procedure ZkomponujZdroj;
  begin
    NovyZdroj:=Turnaj;
    if HHNrSt<>'' then NovyZdroj:=NovyZdroj+HHNrSt;
    if HHVyzn<>'' then NovyZdroj:=NovyZdroj+' '+HHVyzn;
    if HHSpec<>'' then NovyZdroj:=NovyZdroj+' '+HHSpec;
  end;

{------------------------cteni parametru a inicializace---------------}

procedure CtiParams;

  begin
   writeln('HHKonv (C) Emil Vlasak 2002');
   writeln('Conversion of HvdH sources into the full source names');
   writeln;
   if ParamCount=0 then
     begin
       writeln('using: HHKonv <input PGN name>');
       writeln('       output is new.pgn');
       writeln('       and troubles.txt is created with problems description');
       halt;
     end;

   JmenoVstupu:=ParamStr(1);
   JmenoVystupu:=ExtractFileDir(JmenoVstupu)+'new.pgn';

  end;

 {--------------------prace s PGN--------------------}

 procedure OtevriDatabaze;
   begin
   {$I-}
    assign(InPGN,JmenoVstupu);
    if IOResult<>0 then Konec('Input PGN database not found');
    reset(InPGN);
    if IOResult<>0 then Konec('Input PGN database not found');

    assign(OutPGN,JmenoVystupu);
    rewrite(OutPGN);
    if IOResult<>0 then Konec('Cannot create new.pgn.');

    assign(Unknown,'troubles.txt');
    rewrite(Unknown);
    if IOResult<>0 then Konec('Cannot create troubles.txt.');

   {$I+}
   end;

 procedure ZavriDatabaze;
   begin
    close(InPGN);
    close(OutPGN);
    close(Unknown);
   end;

 procedure VyloupniEvent;
  {v PGNLine je radka [Event "neco"] a ja chci to neco do globalni promenne HHZdroj}
  {navic upravit PGNLine aby koncil prvni uvozovkou}
  var pomb:byte;

  begin
   pomb:=pos('"',PGNLine);
   HHZdroj:=copy(PGNLine,pomb+1,length(PGNLine)-pomb-2);
    {dost odflakle, orezu tim posledni uvozovku a zavorku}
   PGNLine:=copy(PGNLine,1, pomb-1);
    {bez uvozovky}
  end;

 procedure VratNovyEvent;
  {doplnit do PGNLine konvertovany retez NovyZdroj}
  begin
   PGNLine:=PGNLine+'"'+NovyZdroj+'"]';

  end;


 procedure ZpracujPGNLine;

  begin
   if pos('[Event ',PGNLine)<>1 then exit; {neni to konvertovana radka}
   inc(Zpracovanych); if (Zpracovanych mod 1000)=0 then writeln(Zpracovanych);
   VyloupniEvent; {do HHZdroj}
   AnalyzujHHZdroj;
   NajdiTurnaj;
   ZkomponujZdroj;
   VratNovyEvent;
   {magicke cislo je 39, k tomu se pridava rezie [Event " ..."]}
   if length(PGNLine)>50 then 
          begin
              inc(Dlouhych); 
              writeln (Unknown, 'to long: '+PGNLine);
          end;
  end;

{----------------main -----------------------}

begin
  Nenalezenych:=0;
  Zpracovanych:=0;
  Dlouhych:=0;

  CtiParams;
{$I-}
  NactiPrevodTurnaje;
  OtevriDatabaze;

  {------- hlavni cykl prevodu----------------}
   while not eof(InPGN) do
     begin
      readln(InPGN, PGNLine);
      if IOResult<>0 then Konec('Cannot read input database');
      ZpracujPGNLine;
      writeln(OutPGN,PGNLine);
      if IOResult<>0 then Konec('Cannot write to output database');
     end;
  ZavriDatabaze;
{$I+}

  writeln('Database converted ',Zpracovanych, ' studies.');
  writeln('Not converted sources: ', Nenalezenych);
  writeln('Long sources: ', Dlouhych);

if ((Nenalezenych>0) or (Dlouhych>0)) then 
  writeln('There are some problems, read the troubls.txt file.')

end.
